// -*-Mode: C++;-*-

// TTY-Grin
// Copyright (C) 2001-2003 Daniel Beer
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef _MAILDIR_H
#define _MAILDIR_H

#include <vector>
#include <time.h>
#include "message_descriptor.h"
#include "message.h"
#include "mailbox.h"

class maildir;

class maildir_message : public message_descriptor {
public:
  maildir_message(maildir *, const char *);
  virtual ~maildir_message(void);
  virtual bool extract(ostream&) const;
  virtual void set_flags(unsigned char);

  const char *get_filename(void) const { return filename.c_str(); }

private:
  maildir *parent;
  string filename, basename;
};

class maildir : public mailbox {
public:
  maildir(const char *);
  virtual ~maildir(void);
  virtual message_descriptor& operator[](int);
  virtual int size(void) const;
  virtual bool append(const message_descriptor&);
  virtual bool append(const message&, unsigned char);
  virtual void expunge(void);

  const char *get_path(void) const { return path.c_str(); }

private:
  string path;
  vector<maildir_message> contents;

  void scan(const char *);
  static void generate_name(char *, size_t);
};

#endif
